package com.edgec.browserbackend.browser.service.Impl;

import com.edgec.browserbackend.account.domain.Account;
import com.edgec.browserbackend.account.repository.AccountRepository;
import com.edgec.browserbackend.browser.ErrorCode.BrowserErrorCode;
import com.edgec.browserbackend.browser.domain.IpResource;
import com.edgec.browserbackend.browser.dto.*;
import com.edgec.browserbackend.browser.repository.IpResourceRepository;
import com.edgec.browserbackend.browser.service.IpResourceService;
import com.edgec.browserbackend.common.commons.error.ClientRequestException;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.util.*;

@Service
public class IpResourceServiceImpl implements IpResourceService {

    private final Logger logger = LoggerFactory.getLogger(IpResourceServiceImpl.class);

    private static String CLOUDAMURL = "https://www.cloudam.cn";
    private static String TESTURL = "http://112.74.13.2";

    @Autowired
    private AccountRepository accountRepository;

    @Autowired
    private IpResourceRepository ipResourceRepository;

    public HttpHeaders buildPostHeader() {
        HttpHeaders header = new HttpHeaders();
        header.setContentType(MediaType.APPLICATION_JSON);
        header.setBearerAuth("5aFM6ntBcLDD8e8PGMXBybx1UsWYYWvQ0jKOal28XoMhaz7gJyxX5GtayPcY6vec");
        return header;
    }

    public HttpHeaders buildGetHeader() {
        HttpHeaders headers = new HttpHeaders();
        headers.setBearerAuth("5aFM6ntBcLDD8e8PGMXBybx1UsWYYWvQ0jKOal28XoMhaz7gJyxX5GtayPcY6vec");
        return headers;
    }

    @Override
    public List<IpResourceDto> buyIp(String username, IpResourceRequestDto ipResourceRequestDto) {
        List<IpResourceDto> ipResourceDtos = new ArrayList<>();
        RestTemplate restTemplate = new RestTemplate();
        HttpHeaders header = buildPostHeader();
        HashMap<String, Object> map = new HashMap<>();
        map.put("name", ipResourceRequestDto.getName());
        map.put("region", ipResourceRequestDto.getRegion());
        map.put("period", String.valueOf(ipResourceRequestDto.getPeriod()));
        map.put("provider", ipResourceRequestDto.getVendor());
        map.put("unit", ipResourceRequestDto.getUnit());
        map.put("amount", String.valueOf(ipResourceRequestDto.getAmount()));
        map.put("instanceSpecKey", String.valueOf(ipResourceRequestDto.getInstanceSpecKey()));
        HttpEntity<Map<String, Object>> httpEntity = new HttpEntity<>(map, header);
        IpBuyResultDto ipBuyResultDto = null;
        try {
            ipBuyResultDto = restTemplate.postForObject(TESTURL + "/intelligroup/ipresources?accountId=superbrowser", httpEntity, IpBuyResultDto.class);
        } catch (Exception e) {
            logger.error("fail to post request", e.getMessage());
            logger.error(e.getMessage());
            throw new ClientRequestException(BrowserErrorCode.INFORMATIONNOTCOMPELETE);
        }
        try {
            if (ipBuyResultDto != null && ipBuyResultDto.getIplist() != null && ipBuyResultDto.getIplist().size() < 1) {
                ipBuyResultDto.getIplist().forEach(x -> {
                    IpInfoResultDto ipInfoResultDto = new IpInfoResultDto();
                    Map<String, String> params = new HashMap<String, String>();
                    params.put("accountId", "superbrowser");
                    params.put("ip", x.getIp());
                    HttpHeaders headers = buildGetHeader();
                    HttpEntity<Map<String, String>> entity = new HttpEntity<>(params, headers);
                    ResponseEntity<String> result = restTemplate.exchange(TESTURL + "/ecc/ipinfo?accountId={accountId}&ip={ip}", HttpMethod.GET, entity, String.class);
                    if (ipInfoResultDto != null && StringUtils.isBlank(ipInfoResultDto.getErrorCode())) {
                        IpResource ipResource = new IpResource();

                    }
                });
            }
        } catch (Exception e) {
            logger.error("fail to post request", e.getMessage());
            logger.error(e.getMessage());
            throw new ClientRequestException(BrowserErrorCode.UNKNOWN);
        }
        return ipResourceDtos;
    }

    @Override
    public void renewIp(String username, IpResourceRequestDto ipResourceRequestDto) {

    }

    @Override
    public void deleteIp(String username, String ipAddr) {

    }

    @Override
    public List<IpResourceDto> getIpList(String username, int type, int page, int amount, FilterDto filterDto) {
        return null;
    }


}
